//minimum search using Numerical Recipies functions,
//necessary initializations, declarations
//and properly (for Numerical Recipies) defined functions
//(c) V.Glazkov, March 2016



#include"energy.h"

//Functions declarations
float _U(float angles[]);//potential energy called by minimization utility
void _grad_U(float angles[],float grad[]);//gradient called by minimization utility
void minsearch(double angles[]);//search over grid for starting approximation

//Functions definitions
float _U(float angles[])
	{
	double E,theta,phi,psi;
	vector3d l[4];
	int i,code;

	theta=(double)angles[1];
	phi=(double)angles[2];
	psi=(double)angles[3];


	for(i=1;i<=3;i++)
		{
		l[i]=l_vec(i,theta,phi,psi,&code);
		}

	E=U(l);

	return((float)E);
	}

void _grad_U(float angles[],float grad[])
	{
	double theta,phi,psi;
	vector3d l[4];
	int i,code;

	theta=(double)angles[1];
	phi=(double)angles[2];
	psi=(double)angles[3];

	for(i=1;i<=3;i++)
		grad[i]=(float)dU_deuler(i,theta,phi,psi,&code);
	}

void minsearch(double angles[])
	{
	double E,Emin,theta,thetamin,phi,phimin,psi,psimin;
	double thetastep,phistep,psistep;
	int i,code;
	vector3d l[4];

	thetastep=M_PI/((double)minsearch_grid);
	phistep=2.*M_PI/((double)minsearch_grid);
	psistep=2.*M_PI/((double)minsearch_grid);

	thetamin=angles[1];
	phimin=angles[2];
	psimin=angles[3];

	for(i=1;i<=3;i++)
		l[i]=l_vec(i,thetamin,phimin,psimin,&code);

	Emin=U(l);

	for(theta=0.;theta<=M_PI;theta+=thetastep)
		for(phi=0.;phi<2.*M_PI;phi+=phistep)
			for(psi=0.;psi<2.*M_PI;psi+=psistep)
				{
				for(i=1;i<=3;i++)
					l[i]=l_vec(i,theta,phi,psi,&code);
				E=U(l);
				if(E<Emin)
					{
					Emin=E;
					thetamin=theta;
					phimin=phi;
					psimin=psi;
					}
				}
	angles[1]=thetamin;
	angles[2]=phimin;
	angles[3]=psimin;
	}